/*
 * Copyright (c) 2005 Anton Antonov <aga@pikenet.ru>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: conrules.h,v 1.19 2011/12/06 15:22:14 babolo Exp $
 */

/*   */
enum states
{ w0    /*   ,   (     */
, w1    /*      */
, r_num /*               */
, w2    /*                     */
, s_num /*                   */
, w_id  /*                   */
, r_id  /*              */
, er    /*                              */
};

/*  */
enum classes
{   no /*                         */
,   hd /*                            */
,   hx /*                              */
,   hX /*                             */
,   ob /*   (open bracket)            */
,   cb /*   (close bracket)           */
,   sp /* , ,   (space) */
,   sl /* / (slash)                                 */
,   co /* : (colon)                                 */
,   po /* . (point)                                 */
,   or /* | (or)                                    */
,   nt /* ! (not)                                   */
,   da /* dash ( - )                                */
,   xx
};

enum classes class[256] =
{no,no,no,no ,no,no,no,no ,no,sp,sp,no ,no,sp,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,sp,nt,no,no ,no,no,no,no ,ob,cb,po,no ,no,da,po,sl
,hd,hd,hd,hd ,hd,hd,hd,hd ,hd,hd,co,no ,no,no,no,no

,no,hX,hX,hX ,hX,hX,hX,hX ,hX,hX,hX,hX ,hX,hX,hX,hX
,hX,hX,hX,hX ,hX,hX,hX,hX ,hX,hX,hX,no ,no,no,no,hX
,no,hx,hx,hx ,hx,hx,hx,hx ,hx,hx,hx,hx ,hx,hx,hx,hx
,hx,hx,hx,hx ,hx,hx,hx,hx ,hx,hx,hx,no ,or,no,no,no

,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no

,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
,no,no,no,no ,no,no,no,no ,no,no,no,no ,no,no,no,no
};

/*Actions*/
#define A_RC  0x4000 /*                                            */
#define A_cr  0x2000 /*  struct ip_fw *rule                                            */
#define A_cX  0x1000 /*   ,     */
#define A_rn   0x800 /*                                               */
#define A_wd   0x400 /*                                                            */
#define A_wo   0x200 /*  F_OR                                                       */
#define A_wn   0x100 /*  F_NOT                                                      */

u_int32_t automat[er][xx] =
/***************************************************************/
/*     (      rule_number       set_number       IDENTIFIER    */
/*  ^    ^          ^       ^         ^      ^        ^        */
/* w0    w1       r_num     w2      s_num   w_id     r_id      */
/*************************************************************************************************************/
/* no         hd  hx        hX        (            )         sp  /  :  .              |              !   -   */
/********************************************************************************************************************/
{{ er,        er, er,       er,  A_cr|w1,          er,       w0, er,er,er,            er,            er, er}/* w0   */
,{ er,A_rn|r_num, er,       er,       er,     A_RC|w0,       w1, er,er,er,            er,            er, er}/* w1   */
,{ er,A_rn|r_num, er,       er,       er,A_wd|A_RC|w0,  A_wd|w2, er,er,er,            er,            er, er}/* r_num*/
,{ er,A_rn|s_num, er,       er,       er,     A_RC|w0,       w2, er,er,er,            er,            er, er}/* w2   */
,{ er,A_rn|s_num, er,       er,       er,A_wd|A_RC|w0,A_wd|w_id, er,er,er,            er,            er, er}/* s_num*/
,{ er,        er, er,A_rn|r_id,       er,     A_RC|w0,     w_id, er,er,er,     A_wo|w_id,     A_wn|w_id, er}/* w_id */
,{ er,A_rn| r_id, er,A_rn|r_id,A_cX|w_id,A_cX|A_RC|w0,A_cX|w_id, er,er,er,A_cX|A_wo|w_id,A_cX|A_wn|w_id, er}/* r_id */
};

/* "  */
enum in_states
{ w_ob   /*       */
, w_xX   /*        */
, next   /*    */
, w_xX2  /*        */
, next2  /*    */
, w_cb   /*       */
, in_end
};

#define A_wr     0x08000 /*    */
#define DASH     0x10000 /* dash                 */
#define MASKLEN  0x20000 /*            */
#define MASK     0x40000 /*                 */

/*       */
u_int32_t in_auto[7][in_end][xx] =
/** no ******* hd ****** hx ****** hX * ( ********* ) ******** sp *************** / ************ : ******* . * | ******* ! ************ - ***/
/**** class 1 (single parameter) ************************************************************************************************************/
{{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er, A_rn|next,A_rn|next,A_rn|next,  er,     in_end,      w_xX,                er,            er,A_rn|next, er,       er,            er}/* w_xX */
 ,{ er, A_rn|next,A_rn|next,A_rn|next,  er,A_wr|in_end, A_wr|w_cb,                er,            er,A_rn|next, er,       er,            er}/* next */
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 2 (ip_addr and port) ************************************************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er, A_rn|next,       er,       er,  er,     in_end,      w_xX,                er,            er,       er, er,       er,            er}/* w_xX */
 ,{ er, A_rn|next,       er,       er,  er,A_wr|in_end,A_wr|w_xX2,                er,            er,A_rn|next, er,       er,            er}/* next */
 ,{ er,A_rn|next2,       er,       er,  er,     in_end,     w_xX2,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,A_rn|next2,       er,       er,  er,A_wr|in_end,A_wr| w_cb,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 3 (integers divided by spaces or range of integers) *****************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er, A_rn|next,       er,       er,  er,     in_end,      w_xX,                er,            er,       er, er,       er,            er}/* w_xX */
 ,{ er, A_rn|next,       er,       er,  er,A_wr|in_end, A_wr|w_xX,                er,            er,       er, er,       er,A_wr|DASH|next}/* next */
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 4 (words or integers divided by spaces) *****************************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er,A_rn|next2,A_rn|next,       er,  er,     in_end,      w_xX,                er,            er,       er, er,A_rn|next,            er}/* w_xX */
 ,{ er,        er,A_rn|next,       er,  er,A_wr|in_end, A_wr|w_xX,                er,            er,       er, er,       er,            er}/* next */
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,A_rn|next2,       er,       er,  er,A_wr|in_end, A_wr|w_cb,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 5 (ip_addr[:mask | /masklen]) ***************************************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er, A_rn|next,       er,       er,  er,     in_end,      w_xX,                er,            er,       er, er,       er,            er}/* w_xX */
 ,{ er, A_rn|next,       er,       er,  er,A_wr|in_end, A_wr|w_xX,A_wr|MASKLEN|next2,A_wr|MASK|w_xX,A_rn|next, er,       er,            er}/* next */
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,A_rn|next2,       er,       er,  er,A_wr|in_end, A_wr|w_xX,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 6 (ip_addr/masklen bitmap) ******************************************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er}/* w_ob */
 ,{ er, A_rn|next,       er,       er,  er,     in_end,      w_xX,                er,            er,       er, er,       er,            er}/* w_xX */
 ,{ er, A_rn|next,       er,       er,  er,         er,A_wr|w_xX2,A_wr|MASKLEN|next2,            er,A_rn|next, er,       er,            er}/* next */
 ,{ er,A_rn|next2,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er}/* w_xX2*/
 ,{ er,A_rn|next2,       er,       er,  er,A_wr|in_end,A_wr|w_xX2,                er,            er,       er, er,       er,            er}/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er}/* w_cb */
 }
/**** class 7 (MAC/masklen MAC/masklen) ******************************************************************************************************/
,{{ er,        er,       er,       er,w_xX,         er,      w_ob,                er,            er,       er, er,       er,            er }/* w_ob */
 ,{ er, A_rn|next,A_rn|next,A_rn|next,  er,     in_end,      w_xX,                er,            er,       er, er,       er,            er }/* w_xX */
 ,{ er, A_rn|next,A_rn|next,A_rn|next,  er,A_wr|in_end, A_wr|w_xX,A_wr|MASKLEN|next2,     A_rn|next,       er, er,       er,            er }/* next */
 ,{ er,        er,       er,       er,  er,         er,        er,                er,            er,       er, er,       er,            er }/* w_xX2*/
 ,{ er,A_rn|next2,       er,       er,  er,A_wr|in_end, A_wr|w_xX,                er,            er,       er, er,       er,            er }/* next2*/
 ,{ er,        er,       er,       er,  er,     in_end,      w_cb,                er,            er,       er, er,       er,            er }/* w_cb */
/** no ******* hd ****** hx ****** hX * ( ********* ) ******** sp *************** / ************ : ******* . * | ******* ! ************ - ***/
}};

struct _i_o {
    char const       *name;
    u_int16_t         parms;
#define  INVALID_CLACC 0x00   /*                                         */
#define  MAX_PARACLASS 0x07   /*                           */
#define  NO_PARACLASS  0x0F   /*                                         */
#define  CLASS_MASK    0x0F   /*                             */
#define  SEQ_INVALID   0x00   /*                                         */
#define  SEQ_OFFSET    0x10   /*       */
#define  ACT_OFFSET    0x80   /*     act_ofs                  */
#define  SEQUENSE_END  0xF0   /*                             */
#define  SEQUENSE_MASK 0xF0   /*                   */
    enum ipfw_opcodes opcode:8;
};
static struct _i_o ipfw_ops[] =
{ {"NOP"          , 0x00, O_NOP          }
, {"IP_SRC"       , 0x55, O_IP_SRC       }
, {"IP_SRC_MASK"  , 0x55, O_IP_SRC_MASK  }
, {"IP_SRC_ME"    , 0x5F, O_IP_SRC_ME    }
, {"IP_SRC_SET"   , 0x56, O_IP_SRC_SET   }
, {"IP_DST"       , 0x55, O_IP_DST       }
, {"IP_DST_MASK"  , 0x55, O_IP_DST_MASK  }
, {"IP_DST_ME"    , 0x5F, O_IP_DST_ME    }
, {"IP_DST_SET"   , 0x56, O_IP_DST_SET   }
, {"IP_SRCPORT"   , 0x53, O_IP_SRCPORT   }
, {"IP_DSTPORT"   , 0x53, O_IP_DSTPORT   }
, {"PROTO"        , 0x51, O_PROTO        }
, {"MACADDR2"     , 0x57, O_MACADDR2     }
, {"MAC_TYPE"     , 0x53, O_MAC_TYPE     }
, {"LAYER2"       , 0x5F, O_LAYER2       }
, {"IN"           , 0x5F, O_IN           }
, {"FRAG"         , 0x5F, O_FRAG         }
, {"RECV"         , 0x51, O_RECV         }
, {"XMIT"         , 0x51, O_XMIT         }
, {"VIA"          , 0x51, O_VIA          }
, {"IPOPT"        , 0x54, O_IPOPT        }
, {"IPLEN"        , 0x53, O_IPLEN        }
, {"IPID"         , 0x53, O_IPID         }
, {"IPTOS"        , 0x54, O_IPTOS        }
, {"IPPRECEDENCE" , 0x51, O_IPPRECEDENCE }
, {"IPTTL"        , 0x53, O_IPTTL        }
, {"IPVER"        , 0x51, O_IPVER        }
, {"UID"          , 0x51, O_UID          }
, {"GID"          , 0x51, O_GID          }
, {"ESTAB"        , 0x5F, O_ESTAB        }
, {"TCPFLAGS"     , 0x54, O_TCPFLAGS     }
, {"TCPWIN"       , 0x51, O_TCPWIN       }
, {"TCPSEQ"       , 0x51, O_TCPSEQ       }
, {"TCPACK"       , 0x51, O_TCPACK       }
, {"ICMPTYPE"     , 0x53, O_ICMPTYPE     }
, {"TCPOPTS"      , 0x54, O_TCPOPTS      }
, {"VERREVPATH"   , 0x5F, O_VERREVPATH   }
#if __FreeBSD_version >= 500000
, {"VERSRCREACH"  , 0x5F, O_VERSRCREACH  }
#endif
, {"PROBE_STATE"  , 0x5F, O_PROBE_STATE  }
, {"KEEP_STATE"   , 0x5F, O_KEEP_STATE   }
, {"LIMIT"        , 0x54, O_LIMIT        }
, {"LIMIT_PARENT" , 0x00, O_LIMIT_PARENT }
, {"LOG"          , 0x91, O_LOG          }
, {"PROB"         , 0x51, O_PROB         }
, {"CHECK_STATE"  , 0xEF, O_CHECK_STATE  }
, {"ACCEPT"       , 0xEF, O_ACCEPT       }
, {"DENY"         , 0xEF, O_DENY         }
, {"REJECT"       , 0xE1, O_REJECT       }
, {"COUNT"        , 0xEF, O_COUNT        }
, {"SKIPTO"       , 0xE1, O_SKIPTO       }
, {"PIPE"         , 0xE1, O_PIPE         }
, {"QUEUE"        , 0xE1, O_QUEUE        }
, {"DIVERT"       , 0xE1, O_DIVERT       }
, {"TEE"          , 0xE1, O_TEE          }
, {"FORWARD_IP"   , 0xE2, O_FORWARD_IP   }
, {"FORWARD_MAC"  , 0xE0, O_FORWARD_MAC  }
#if __FreeBSD_version >= 700000
, {"NAT"          , 0xE1, O_NAT          }
#endif
#if __FreeBSD_version > 800099
, {"REASS"        , 0x00, O_REASS        }
#endif
, {"IPSEC"        , 0x00, O_IPSEC        }
, {"IP_SRC_LOOKUP", 0x53, O_IP_SRC_LOOKUP}
, {"IP_DST_LOOKUP", 0x53, O_IP_DST_LOOKUP}
#if __FreeBSD_version >= 600000
, {"ANTISPOOF"    , 0x5F, O_ANTISPOOF    }
, {"JAIL"         , 0x00, O_JAIL         }
, {"ALTQ"         , 0x00, O_ALTQ         }
, {"DIVERTED"     , 0x51, O_DIVERTED     }
, {"TCPDATALEN"   , 0x00, O_TCPDATALEN   }
, {"IP6_SRC"      , 0x00, O_IP6_SRC      }
, {"IP6_SRC_ME"   , 0x00, O_IP6_SRC_ME   }
, {"IP6_SRC_MASK" , 0x00, O_IP6_SRC_MASK } 
, {"IP6_DST"      , 0x00, O_IP6_DST      }
, {"IP6_DST_ME"   , 0x00, O_IP6_DST_ME   }
, {"IP6_DST_MASK" , 0x00, O_IP6_DST_MASK }
, {"FLOW6ID"      , 0x00, O_FLOW6ID      }
, {"ICMP6TYPE"    , 0x00, O_ICMP6TYPE    }
, {"EXT_HDR"      , 0x00, O_EXT_HDR      }
, {"IP6"          , 0x00, O_IP6          }
, {"NETGRAPH"     , 0xE0, O_NETGRAPH     }
, {"NGTEE"        , 0xE0, O_NGTEE        }
, {"IP4"          , 0x00, O_IP4          }
, {"UNREACH6"     , 0xE0, O_UNREACH6     }
, {"TAG"          , 0x51, O_TAG          }
, {"TAGGED"       , 0x53, O_TAGGED       }
#endif
#if __FreeBSD_version >= 700100
, {"SETFIB"       , 0xE0, O_SETFIB       }
, {"FIB"          , 0x00, O_FIB          }
#endif
, {NULL           , 0x00, O_LAST_OPCODE  }
};

struct _s_x {
    char const *s;
    int x;
};

static struct _s_x f_ipopts[] =
{ { "ssrr"     , IP_FW_IPOPT_SSRR}
, { "lsrr"     , IP_FW_IPOPT_LSRR}
, { "rr"       , IP_FW_IPOPT_RR  }
, { "ts"       , IP_FW_IPOPT_TS  }
, { "ip_option", 0               }
, { NULL       , 0               }
};

static struct _s_x f_iptos[] =
{ { "lowdelay"     , IPTOS_LOWDELAY   }
, { "throughput"   , IPTOS_THROUGHPUT }
, { "reliability"  , IPTOS_RELIABILITY}
, { "mincost"      , IPTOS_MINCOST    }
#ifdef IPTOS_CE
, { "congestion"   , IPTOS_CE         }
#endif
#ifdef IPTOS_ECT
, { "ecntransport" , IPTOS_ECT        }
#endif
, { "ip_tos_option", 0                }
, { NULL           , 0                }
};

static struct _s_x f_tcpflags[] =
{ { "syn"     , TH_SYN  }
, { "fin"     , TH_FIN  }
, { "ack"     , TH_ACK  }
, { "psh"     , TH_PUSH }
, { "rst"     , TH_RST  }
, { "urg"     , TH_URG  }
, { "tcp_flag", 0       }
, { NULL      , 0       }
};

static struct _s_x limit_masks[] =
{ {"all"     , DYN_SRC_ADDR | DYN_SRC_PORT | DYN_DST_ADDR | DYN_DST_PORT}
, {"src_addr", DYN_SRC_ADDR                                             }
, {"src_port", DYN_SRC_PORT                                             }
, {"dst_addr", DYN_DST_ADDR                                             }
, {"dst_port", DYN_DST_PORT                                             }
, {NULL      , 0                                                        }
};

static struct _s_x f_tcpopts[] =
{ { "mss"       , IP_FW_TCPOPT_MSS   }
, { "maxseg"    , IP_FW_TCPOPT_MSS   }
, { "window"    , IP_FW_TCPOPT_WINDOW}
, { "sack"      , IP_FW_TCPOPT_SACK  }
, { "ts"        , IP_FW_TCPOPT_TS    }
, { "timestamp" , IP_FW_TCPOPT_TS    }
, { "cc"        , IP_FW_TCPOPT_CC    }
, { "tcp option", 0                  }
, { NULL        , 0                  }
};
